/*****************ͷļ*************************/
#include "fsl_common.h"
#include "fsl_port.h"
#include "fsl_gpio.h"
#include "adc_Interrupt.h"
#include "fsl_adc16.h"

uint32_t g_Adc12ConversionValue = 0;    //ADCĴֵ
uint32_t g_Adc12_Value = 0; //תĵѹֵֵΪ0-3040
uint32_t g_Adc12Count = 0;

/*****************ADCʼ*************************
    * adc16ConfigStruct.referenceVoltageSource = kADC16_ReferenceVoltageSourceVref; //ѡVREFLΪοѹ
    * adc16ConfigStruct.clockSource = kADC16_ClockSourceAsynchronousClock;
    * adc16ConfigStruct.enableAsynchronousClock = true;
    * adc16ConfigStruct.clockDivider = kADC16_ClockDivider8;
    * adc16ConfigStruct.resolution = kADC16_ResolutionSE12Bit; //ֱΪ12λֵ4096
    * adc16ConfigStruct.longSampleMode = kADC16_LongSampleDisabled;
    * adc16ConfigStruct.enableHighSpeed = false;
    * adc16ConfigStruct.enableLowPower = false;
    * adc16ConfigStruct.enableContinuousConversion = false;
*******************************************************/
void ADC12_InterrputInit()   //ADCʼ
{
    /*ADCֱѡ12λ,ֵ4096*/
    /*οѹѡVREFLVDDA3.3V)*/
    adc16_config_t adc16ConfigStruct;
    adc16_channel_config_t adc16ChannelConfigStruct;
    EnableIRQ(ADC0_IRQn);
    ADC16_GetDefaultConfig(&adc16ConfigStruct);
    adc16ConfigStruct.enableContinuousConversion = true;    //ת
    ADC16_Init(ADC0, &adc16ConfigStruct);
    ADC16_EnableHardwareTrigger(ADC0, false);   //ADC
    adc16ChannelConfigStruct.channelNumber  = 5u;   //ѡͨ5
    adc16ChannelConfigStruct.enableInterruptOnConversionCompleted = true; //ʹADCжϴ־
    ADC16_SetChannelConfig(ADC0, 0u, &adc16ChannelConfigStruct);
}

uint32_t adc_ReturnValue()
{
    g_Adc12_Value = g_Adc12ConversionValue * 3040/ g_Adc12_12bitFullRange;
    return g_Adc12_Value;  //ѹֵŴ1000
}

void ADC0_IRQHandler(void)
{
    g_Adc12ConversionValue = ADC16_GetChannelConversionValue(ADC0, 0u); //ȡADCĴֵ
    g_Adc12Count++;
    g_Adc12Count %= 1000;
    SDK_ISR_EXIT_BARRIER;   //жϱ־λ
}

